<?php
error_reporting(E_ALL);
ini_set('display_errors', 1);

require_once __DIR__ . "/vendor/autoload.php";

$username = "zehavie";
$password = "zehavie";

$imageDirectoryUrl = "http://soup.julce.com/natuerlich_scraper/images";
$imageDirectoryPath = __DIR__ . "/images";
$tmpDirectoryPath = __DIR__ . "/tmp";
$logsRepositoryPath = __DIR__ . "/data/logs.sqlite";
$productListPath = __DIR__ . "/data/product-list.dat";
$configPath = __DIR__ . "/data/config.dat";
$nextRunPath = __DIR__ . "/data/next-run.txt";

session_start();

if (!file_exists($nextRunPath)) touch($nextRunPath);
$nextRun = file_get_contents($nextRunPath);
if ($nextRun == null) $nextRun = time();


if (!file_exists($configPath)) touch($configPath);
$configData = unserialize(file_get_contents($configPath));
if ($configData == false) $configData = [];

$config = new \Scraper\Config([
    new \Scraper\ConfigOption("cronExpression", "", "Cron expression"),
    new \Scraper\ConfigOption("uploaderUrlList", "", "List of urls to uploaders scripts. Each in new line")
]);

$config->setData($configData);


$logger = new \Monolog\Logger("Default");
$handler = new \Monolog\Handler\StreamHandler("php://stdout");

$logger->pushHandler($handler);

$retrySubscriber = new \GuzzleHttp\Subscriber\Retry\RetrySubscriber([
    "filter" => \GuzzleHttp\Subscriber\Retry\RetrySubscriber::createStatusFilter()
]);

$client = new \GuzzleHttp\Client([
    "defaults" => [
        "verify" => false,
        "headers" => [
        ],
        "cookies" => true
    ]
]);
$client->getEmitter()->attach($retrySubscriber);



$pdo = new \PDO("sqlite:$logsRepositoryPath", null, null, [
    PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION
]);
$logsRepository = new \Scraper\LogsRepository($pdo);