<?php

require_once "config.php";

if(!isset($_SESSION['loggedIn']) || $_SESSION['loggedIn'] != true){
    header('Location: login.php');
    exit;
}

header("Cache-Control: no-cache, no-store, must-revalidate"); // HTTP 1.1.
header("Pragma: no-cache"); // HTTP 1.0.
header("Expires: 0"); // Proxies.
?><!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title>Cron admin</title>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"
          integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css"
          integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.1/css/bootstrap-select.min.css">
    <style>
        html {
            position: relative;
            min-height: 100%;
        }

        body {
            /* Margin bottom by footer height */
            margin-bottom: 60px;
            margin-top: 20px;
            background-color: #f0f0f0;
        }

        .footer {
            position: fixed;
            bottom: 0;
            width: 100%;
            /* Set the fixed height of the footer here */
            height: 60px;
            background-color: #ffffff;
            border-top: #999 2px solid;
            z-index: 1000;
        }

        .footer .footer-button-group {
            margin-top: 13px;
            float: right;
        }

        #body {
            display: none;
        }

    </style>
</head>
<body>
<div class="modal fade" id="loading-modal" tabindex="-1" data-backdrop="static" data-keyboard="false">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title" id="loading-modal-header">Processing...</h4>
            </div>
            <div class="modal-body" style="text-align: center">
                <img src="loading.gif" id="loading-gif"/>
            </div>
        </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
<div id="body">
    <div class="container">
        <!-- Nav tabs -->
        <ul class="nav nav-tabs" role="tablist">
            <li role="presentation" class="active"><a href="#config" aria-controls="profile" role="tab"
                                                      data-toggle="tab">Configuration</a>
            </li>
            <li role="presentation"><a href="#logs" aria-controls="profile" role="tab"
                                                      data-toggle="tab">Logs</a>
            </li>
        </ul>

        <!-- Tab panes -->
        <form>
            <div class="tab-content">
                <div role="tabpanel" class="tab-pane active" id="config">
                    <h3>Crurrent server time: <?php echo date("Y-m-d H:i") ?>. Next run: <?php echo date("Y-m-d H:i", $nextRun) ?></h3>
                    <hr/>
                    <h1>Configuration:</h1>
                    <?php foreach ($config->getAll() as $key => $configOption): ?>
                        <input type="hidden" name="config[<?php echo $configOption->id ?>][]" value=""/>
                        <div class="form-group">
                            <label for="config_<?php echo $configOption->id ?>"><?php echo $configOption->displayName ?></label>
                            <?php if ($key == "uploaderUrlList"): ?>
                                <textarea class="form-control" id="config_<?php echo $configOption->id ?>"
                                          name="config[<?php echo $configOption->id ?>]"
                                          rows="5"
                                ><?php echo $configOption->value ?></textarea>
                            <?php else: ?>
                                <input type="text" class="form-control" id="config_<?php echo $configOption->id ?>"
                                       name="config[<?php echo $configOption->id ?>]"
                                       value="<?php echo $configOption->value ?>"/>
                            <?php endif ?>
                        </div>
                    <?php endforeach ?>
                </div>

                <div role="tabpanel" class="tab-pane" id="logs">
                    <h1>Logs:</h1><table class="table table-striped table-bordered">
                        <thead>
                        <tr>
                            <th>Time</th>
                            <th>Message</th>
                        </tr>
                        </thead>
                        <tbody>
                        <?php foreach ($logsRepository->fetchAll() as $log): ?>
                            <tr <?php if ($log->isError) echo "class='danger'" ?>>
                                <td><?php echo date("Y-m-d H:i", $log->insertTimestamp) ?></td>
                                <td><?php echo $log->message ?></td>
                            </tr>
                        <?php endforeach; ?>
                        </tbody>
                    </table>
                </div>
            </div>

        </form>
    </div>

    <footer class="footer">
        <div class="container">
            <div class="footer-button-group">
                <button class="btn btn-primary" id="save-button"><span class="glyphicon glyphicon-save"
                                                                       aria-hidden="true"></span> Save
                </button>
            </div>
        </div>
    </footer>
</div>


<!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<!-- Latest compiled and minified JavaScript -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"
        integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
        crossorigin="anonymous"></script>
<!-- Latest compiled and minified JavaScript -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.1/js/bootstrap-select.min.js"></script>

<script>

    function openLoadingModal(message, callback = function () {
    }, timeout = 1000) {
        $("#loading-modal-header").text(message);
        $("#loading-modal").modal("show");
        $("#loading-gif").show();
        setTimeout(callback, timeout);
    }
    function closeLoadingModal(message, callback = function () {
    }, timeout = 1000) {
        $("#loading-modal-header").text(message);
        $("#loading-gif").hide();
        setTimeout(function () {
            $("#loading-modal").modal("hide");
            callback()
        }, timeout);
    }


    $("#loading-modal").modal({});
    $(document).ready(function () {
        $.ajaxSetup({cache: false});

        openLoadingModal("Initializing data...", function () {
            $("#save-button").on("click", function () {
                openLoadingModal("Saving data...");
                var formData = $("form").serialize();

                $.post("ajax.php?action=save", formData, function (data) {
                    if (data.success == true) {
                        closeLoadingModal("Data saved!");
                        window.location.reload();
                    } else {
                        alert(data.error);
                        closeLoadingModal("Data NOT saved!");
                    }
                }, 'json');
            });

            closeLoadingModal("Done!", function () {
                $("#body").fadeIn(400);
            });
        });

    });
</script>


</body>
</html>