<?php
/**
 * Created by PhpStorm.
 * User: jasko
 * Date: 17.12.2016
 * Time: 18:28
 */

namespace Scraper;


class NatuerlichCategory
{
    const BREADCRUMB_SEPARATOR = " / ";

    public $id;
    public $name;
    public $url;


    /**
     * @var NatuerlichCategory
     */
    protected $parent;
    /**
     * @var NatuerlichCategory[]
     */
    protected $childList = [];

    /**
     * NatuerlichCategory constructor.
     * @param $id
     * @param $name
     * @param $url
     */
    public function __construct($id, $name, $url)
    {
        $this->id = $id;
        $this->name = $name;
        $this->url = $url;
    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @return mixed
     */
    public function getUrl()
    {
        return $this->url;
    }


    /**
     * @return NatuerlichCategory
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * @param NatuerlichCategory $parent
     */
    public function setParent(NatuerlichCategory $parent)
    {
        $this->parent = $parent;
        $this->parent->_addChild($this);
    }

    /**
     * @return NatuerlichCategory[]
     */
    public function getChildList()
    {
        return $this->childList;
    }

    /**
     * @param NatuerlichCategory $category
     */
    public function _addChild(NatuerlichCategory $category)
    {
        $this->childList[] = $category;
    }


    public function getBreadcrumb()
    {
        if ($this->parent == null) {
            return [$this->name];
        } else {
            $breadcrumb = $this->parent->getBreadcrumb();
            $breadcrumb[] = $this->name;
            return $breadcrumb;
        }
    }

    public function getBreadcrumbAsString()
    {
        return implode(self::BREADCRUMB_SEPARATOR, $this->getBreadcrumb());
    }
}