<?php

require_once "config.php";


$action = $_GET['action'];

try {

    if ($action == "make-orders") {
        $handler = new \Monolog\Handler\StreamHandler(__DIR__ . "/logs.txt");
        $logger->pushHandler($handler);
        $orderManager->run($hikashopList);
        echo json_encode([
            "success" => true
        ]);
    }
    if ($action == "delete-order-result") {
        $id = $_POST['id'];
        $orderResultRepository->delete($id);

        echo json_encode([
            "success" => true
        ]);
    }

    if ($action == "save") {
        //config
        $configData = $_POST['config'];
        file_put_contents($configPath, serialize($configData));

        $cron = \Cron\CronExpression::factory($configData["cronExpression"]);
        $nextRun = $cron->getNextRunDate()->getTimestamp();
        file_put_contents($nextRunPath, $nextRun);

        if (isset($_POST['hikashop'])) {
            $hikashopData = $_POST['hikashop'];
            $keys = array_keys($hikashopData["url"]);
            $hikashopList = [];
            foreach ($keys as $key) {
                $hikashopList[] = new \Ordering\Hikashop(
                    $hikashopData["url"][$key],
                    $hikashopData["name"][$key],
                    $hikashopData["username"][$key],
                    $hikashopData["password"][$key]
                );
            }
            file_put_contents($hikashopListPath, serialize($hikashopList));
        }
        echo json_encode([
            "success" => true
        ]);
    }
} catch (\Exception $e) {
    echo json_encode([
        "success" => false,
        "error" => $e->getMessage() . " - " . $e->getTraceAsString()
    ]);
}
