<?php
error_reporting(E_ALL);
ini_set('display_errors', 'On');

session_start();

require_once __DIR__ . "/vendor/autoload.php";


$username = "zehavie";
$password = "zehavie";


$nextRunPath = __DIR__ . "/data/next-run.txt";
$configPath = __DIR__ . "/data/config.dat";
$hikashopListPath = __DIR__ . "/data/hikashop-list.dat";
$orderResultRepositoryPath = __DIR__ . "/data/order-result-repository.sqlite";

if (!file_exists($nextRunPath)) touch($nextRunPath);
$nextRun = file_get_contents($nextRunPath);
if ($nextRun == null) $nextRun = time();

if (!file_exists($hikashopListPath)) touch($hikashopListPath);
$hikashopList = unserialize(file_get_contents($hikashopListPath));
if ($hikashopList == null) $hikashopList = [];

if (!file_exists($configPath)) touch($configPath);
$configData = unserialize(file_get_contents($configPath));
if ($configData == false) $configData = [];

$config = new \Ordering\Config([
    new \Ordering\ConfigOption("cronExpression", "", "Cron expression"),
    new \Ordering\ConfigOption("natuerlichUsername", "", "natuerlich.com username"),
    new \Ordering\ConfigOption("natuerlichPassword", "", "natuerlich.com password"),
    new \Ordering\ConfigOption("minOrderPrice", "", "min order price")
]);

$config->setData($configData);


$natuerlichClient = new \GuzzleHttp\Client([
    "base_url" => "https://natuerlich.de",
    "defaults" => [
        "verify" => false,
        "headers" => [
        ],
        "cookies" => true
    ]
]);

$natuerlichApi = new \Ordering\NatuerlichApi($natuerlichClient);


$logger = new \Monolog\Logger("Default");


$pdo = new \PDO("sqlite:$orderResultRepositoryPath", null, null, [
    PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION
]);
$orderResultRepository = new \Ordering\OrderResultRepository($pdo);

$orderManager = new \Ordering\OrderManager($logger, $natuerlichApi, $orderResultRepository, $config);