<?php

require_once "config.php";

if (!isset($_SESSION['loggedIn']) || $_SESSION['loggedIn'] != true) {
    header('Location: login.php');
    exit;
}

header("Cache-Control: no-cache, no-store, must-revalidate"); // HTTP 1.1.
header("Pragma: no-cache"); // HTTP 1.0.
header("Expires: 0"); // Proxies.
?><!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- The above 3 meta tags *must* come first in the head; any other head content must come *after* these tags -->
    <title>Ordering script</title>

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css"
          integrity="sha384-BVYiiSIFeK1dGmJRAkycuHAHRg32OmUcww7on3RYdg4Va+PmSTsz/K68vbdEjh4u" crossorigin="anonymous">

    <!-- Optional theme -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap-theme.min.css"
          integrity="sha384-rHyoN1iRsVXV4nD0JutlnGaslCJuC7uwjduW9SVrLvRYooPp2bWYgmgJQIXwl/Sp" crossorigin="anonymous">

    <!-- Latest compiled and minified CSS -->
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.1/css/bootstrap-select.min.css">
    <style>
        html {
            position: relative;
            min-height: 100%;
        }

        body {
            /* Margin bottom by footer height */
            margin-bottom: 60px;
            margin-top: 20px;
            background-color: #f0f0f0;
        }

        .footer {
            position: fixed;
            bottom: 0;
            width: 100%;
            /* Set the fixed height of the footer here */
            height: 60px;
            background-color: #ffffff;
            border-top: #999 2px solid;
            z-index: 1000;
        }

        .footer .footer-button-group {
            margin-top: 13px;
            float: right;
        }

        #body {
            display: none;
        }

        .popover {
            max-width: 50%;
        }

    </style>
</head>
<body>
<div class="form-inline" id="hikashop-template" style="display: none">
    <div class="form-group" style="width: 10%">
        <input type="text" class="form-control" title="name" placeholder="name"
               name="hikashop[name][]"
               value=""
               style="width:100%"/>
    </div>
    <div class="form-group" style="width: 30%">
        <input type="text" class="form-control" title="url" placeholder="url"
               name="hikashop[url][]"
               value=""
               style="width:100%"/>
    </div>
    <div class="form-group" style="width: 20%">
        <input type="text" class="form-control" title="username" placeholder="username"
               name="hikashop[username][]"
               value=""
               style="width:100%"/>
    </div>
    <div class="form-group" style="width: 20%">
        <input type="text" class="form-control" title="password" placeholder="password"
               name="hikashop[password][]"
               value=""
               style="width:100%"/>
    </div>
    <div class="form-group" style="width: 10%">
        <button class="btn btn-danger remove-hikashop"><span class="glyphicon glyphicon-remove"
                                                             aria-hidden="true"></span></button>
    </div>
    <hr/>
</div>


<div class="modal fade" id="loading-modal" tabindex="-1" data-backdrop="static" data-keyboard="false">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title" id="loading-modal-header">Processing...</h4>
            </div>
            <div class="modal-body" style="text-align: center">
                <img src="loading.gif" id="loading-gif"/>
            </div>
        </div><!-- /.modal-content -->
    </div><!-- /.modal-dialog -->
</div><!-- /.modal -->
<div id="body">
    <div class="container">
        <!-- Nav tabs -->
        <ul class="nav nav-tabs" role="tablist">
            <li role="presentation" class="active"><a href="#config" aria-controls="profile" role="tab"
                                                      data-toggle="tab">Configuration</a>
            </li>
            <li role="presentation" class=""><a href="#hikashop" aria-controls="profile" role="tab"
                                                data-toggle="tab">Websites</a>
            </li>
            <li role="presentation" class=""><a href="#order" aria-controls="profile" role="tab"
                                                data-toggle="tab">Orders</a>
            </li>
        </ul>

        <!-- Tab panes -->
        <form method="POST">
            <div class="tab-content">
                <div role="tabpanel" class="tab-pane active" id="config">
                    <h3>Crurrent server time: <?php echo date("Y-m-d H:i") ?>. Next
                        run: <?php echo date("Y-m-d H:i", $nextRun) ?></h3>
                    <hr/>
                    <h1>Configuration:</h1>
                    <?php foreach ($config->getAll() as $key => $configOption): ?>
                        <input type="hidden" name="config[<?php echo $configOption->id ?>][]" value=""/>
                        <div class="form-group">
                            <label for="config_<?php echo $configOption->id ?>"><?php echo $configOption->displayName ?></label>
                            <?php if ($key == "uploaderUrlList"): ?>
                                <textarea class="form-control" id="config_<?php echo $configOption->id ?>"
                                          name="config[<?php echo $configOption->id ?>]"
                                          rows="5"
                                ><?php echo $configOption->value ?></textarea>
                            <?php else: ?>
                                <input type="text" class="form-control" id="config_<?php echo $configOption->id ?>"
                                       name="config[<?php echo $configOption->id ?>]"
                                       value="<?php echo $configOption->value ?>"/>
                            <?php endif ?>
                        </div>
                    <?php endforeach ?>
                </div>
                <div role="tabpanel" class="tab-pane" id="hikashop">
                    <h1>Websites:</h1>
                    <div id="hikashop-list-container">
                        <div id="hikashop-list">
                            <?php foreach ($hikashopList as $key => $hikashop): ?>
                                <div class="form-inline">
                                    <div class="form-group" style="width: 10%">
                                        <input type="text" class="form-control" title="name" placeholder="name"
                                               name="hikashop[name][]"
                                               value="<?php echo $hikashop->name ?>"
                                               style="width:100%"/>
                                    </div>
                                    <div class="form-group" style="width: 30%">
                                        <input type="text" class="form-control" title="url" placeholder="url"
                                               name="hikashop[url][]"
                                               value="<?php echo $hikashop->url ?>"
                                               style="width:100%"/>
                                    </div>
                                    <div class="form-group" style="width: 20%">
                                        <input type="text" class="form-control" title="username" placeholder="username"
                                               name="hikashop[username][]"
                                               value="<?php echo $hikashop->username ?>"
                                               style="width:100%"/>
                                    </div>
                                    <div class="form-group" style="width: 20%">
                                        <input type="text" class="form-control" title="password" placeholder="password"
                                               name="hikashop[password][]"
                                               value="<?php echo $hikashop->password ?>"
                                               style="width:100%"/>
                                    </div>
                                    <div class="form-group" style="width: 10%">
                                        <button class="btn btn-danger remove-hikashop"><span
                                                    class="glyphicon glyphicon-remove" aria-hidden="true"></span>
                                        </button>
                                    </div>
                                    <hr/>
                                </div>
                            <?php endforeach ?>
                        </div>
                        <button class="btn btn-primary push-right" id="add-hikashop">Add shop</button>
                    </div>
                </div>

                <div role="tabpanel" class="tab-pane" id="order">
                    <h1>Orders:</h1>
                    <table class="table table-striped table-bordered">
                        <thead>
                        <tr>
                            <th>Id</th>
                            <th>Order number</th>
                            <th>Shop</th>
                            <th>Processed</th>
                            <th>Message</th>
                            <th></th>
                        </tr>
                        </thead>
                        <tbody>
                        <?php foreach ($orderResultRepository->fetchYoungerThan(time() - 3600 * 24 * 7) as $orderResult): ?>
                            <tr <?php if ($orderResult->success == false) echo "class='danger'" ?>>
                                <td>
                                    <a href="<?php echo $orderResult->order->getAdminUrl() ?>" target="_blank">
                                        <?php echo $orderResult->getId() ?>
                                    </a>
                                </td>
                                <td><?php echo $orderResult->order->orderNumber ?></td>
                                <td><?php echo $orderResult->order->hikashop->name ?></td>
                                <td><?php echo date("Y-m-d H:i", $orderResult->insertTimestamp) ?></td>

                                <?php if ($orderResult->success): ?>
                                    <td></td>
                                <?php else: ?>
                                    <td>
                                        <button data-placement="top"
                                                data-container="body"
                                                type="button" class="btn btn-warning" data-toggle="popover"
                                                title="Error"
                                                data-content="<?php echo $orderResult->message ?>">Show error
                                        </button>
                                    </td>
                                <?php endif ?>
                                <td>
                                    <button type="button" class="btn btn-danger delete-order-result" aria-label="remove"
                                            data-id="<?php echo $orderResult->getId() ?>">
                                        <span class="glyphicon glyphicon-remove" aria-hidden="true"></span>
                                    </button>
                                </td>
                            </tr>
                        <?php endforeach; ?>
                        </tbody>
                    </table>
                </div>
            </div>
        </form>
    </div>

    <footer class="footer">
        <div class="container">
            <div class="footer-button-group">
                <button class="btn btn-primary" id="make-orders"><span class="glyphicon glyphicon-shopping-cart"
                                                                       aria-hidden="true"></span>Make orders
                </button>
                <button class="btn btn-primary" id="save-button"><span class="glyphicon glyphicon-save"
                                                                       aria-hidden="true"></span> Save
                </button>
            </div>
        </div>
    </footer>
</div>


<!-- jQuery (necessary for Bootstrap's JavaScript plugins) -->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
<!-- Latest compiled and minified JavaScript -->
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"
        integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa"
        crossorigin="anonymous"></script>
<!-- Latest compiled and minified JavaScript -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.12.1/js/bootstrap-select.min.js"></script>

<script>

    function openLoadingModal(message, callback = function () {
    }, timeout = 1000) {
        $("#loading-modal-header").text(message);
        $("#loading-modal").modal("show");
        $("#loading-gif").show();
        setTimeout(callback, timeout);
    }
    function closeLoadingModal(message, callback = function () {
    }, timeout = 1000) {
        $("#loading-modal-header").text(message);
        $("#loading-gif").hide();
        setTimeout(function () {
            $("#loading-modal").modal("hide");
            callback()
        }, timeout);
    }


    $("#loading-modal").modal({});
    $(document).ready(function () {

        $.ajaxSetup({cache: false});

        $("#add-hikashop").on("click", function (e) {
            e.preventDefault();
            var hikashopNode = $("#hikashop-template").clone();
            hikashopNode.show();
            hikashopNode.removeAttr("id");
            $("#hikashop-list").append(hikashopNode);

            hikashopNode.find(".remove-hikashop").on("click", function (e) {
                e.preventDefault();
                $(this).closest(".form-inline").remove();
            });
        });

        $(".remove-hikashop").on("click", function (e) {
            e.preventDefault();
            $(this).closest(".form-inline").remove();
        });

        openLoadingModal("Initializing data...", function () {
            $("#save-button").on("click", function () {
                openLoadingModal("Saving data...");
                var formData = $("form").serialize();

                $.post("ajax.php?action=save", formData, function (data) {
                    if (data.success == true) {
                        closeLoadingModal("Data saved!");
                    } else {
                        alert(data.error);
                        closeLoadingModal("Data NOT saved!");
                    }
                }, 'json');
            });

            closeLoadingModal("Done!", function () {
                $("#body").fadeIn(400);
            });

        });

        $(".delete-order-result").on("click", function (e) {
            e.preventDefault();
            var $this = $(this);
            openLoadingModal("Deleting data...");
            var id = $this.attr("data-id");
            $.post("ajax.php?action=delete-order-result", {id: id}, function (data) {
                if (data.success == true) {
                    closeLoadingModal("Done!");
                    $this.closest("tr").remove();
                } else {
                    alert(data.error);
                    closeLoadingModal("Errors" +
                        "!");
                }
            }, 'json')
        });
        $("#make-orders").on("click", function(e){
            e.preventDefault();
            openLoadingModal("Deleting data...");
            $.get("ajax.php?action=make-orders", function(data){
                if (data.success == true) {
                    closeLoadingModal("Done!");
                    window.location.reload();
                } else {
                    alert(data.error);
                    closeLoadingModal("Errors!");
                }
            }, 'json')

        });
        $('[data-toggle="popover"]').popover();
    });

</script>


</body>
</html>