<?php

namespace Ordering;


class Config
{
    /**
     * @var ConfigOption[]
     */
    protected $optionList;

    /**
     * Config constructor.
     * @param ConfigOption[] $optionList
     */
    public function __construct($optionList)
    {
        foreach($optionList as $option){
            $this->optionList[$option->id] = $option;
        }
    }

    public function setData($data)
    {

        foreach ($data as $key => $value) {
            if(key_exists($key, $this->optionList)) {
                $this->optionList[$key]->value = $value;
            }
        }
    }

    public function get($key)
    {
        if (!isset($this->optionList[$key])) return null;
        return $this->optionList[$key]->value;
    }

    public function getAll()
    {
        return $this->optionList;
    }

}